program stiff


  implicit DOUBLE PRECISION  (a-h,o-z)
  dimension a(2,2), aa(2,2), u(2), u_n(2), f(2), ypp(2), f1(2), f2(2), est(2)

  ifile = 10

  write(*,*) "Put method type (1=explicit), (2= implicit)"
  read(*,*) i_method

  write(*,*) "Put $b$"
  read(*,*) x_max

  write(*,*) "Put time step $h$"
  read(*,*) tau

  if(i_method .eq. 1) then
     print*,'Explicit Euler method'
  elseif(i_method .eq. 2) then
     print*,'Implicit Euler method'
  elseif(i_method .eq. 3) then
     print*,'Crank-Nicolson method'
  else
     print*,'Unknown method'
     stop
  endif

  tol = 1E-3
  
  print*,'Solution at interval  (0., ',x_max,')'
  print*,'step h = ',tau
  print*

  a(1,1) = 998.0D+00
  a(1,2) = 1998.0D+00
  a(2,1) = -999.0D+00
  a(2,2) = -1999.0D+00

  k_max = x_max/tau
  time = 0.

  !     IC
  u(1) = 1.0D+00
  u(2) = 0.0D+00

  open(ifile, file='u_h' , status='UNKNOWN')

  if(i_method .eq. 1) then
     write(ifile,'(3es14.6,i5)') 0., u(1), u(2), 0
     do i=1, k_max

        u_n(1) = u(1) + tau*(a(1,1)* u(1) + a(1,2)*u(2) )
        u_n(2) = u(2) + tau*(a(2,1)* u(1) + a(2,2)*u(2) )
        time = time + tau
        u(1) = u_n(1)
        u(2) = u_n(2)

        !write(*,*) time, u(1), u(2), i
        write(ifile,'(3es14.6,i5)') time, u(1), u(2), i
     enddo

  elseif(i_method .eq. 2) then

     write(ifile,'(4es14.6)') 0., u(1), u(2), 0.
     do i=1, k_max

        aa(1,1) = 1.D+00 - tau*a(1,1)
        aa(1,2) =  - tau*a(1,2)
        aa(2,1) =  - tau*a(2,1)
        aa(2,2) = 1.D+00 - tau*a(2,2)

        det = aa(1,1)*aa(2,2) - aa(1,2)*aa(2,1)

        det1 = u(1)*aa(2,2) - u(2)*aa(1,2)
        det2 = u(2)*aa(1,1) - u(1)*aa(2,1)

        u_n(1) = det1/det
        u_n(2) = det2/det

        f1(1) = a(1,1)* u(1) + a(1,2)*u(2) 
        f1(2) = a(2,1)* u(1) + a(2,2)*u(2) 
        
        f2(1) = a(1,1)* u_n(1) + a(1,2)*u_n(2) 
        f2(2) = a(2,1)* u_n(1) + a(2,2)*u_n(2)

        ypp(1:2) = abs(f1(1:2) - f2(1:2))/ tau
        est(1:2) = 0.5 * tau**2 * ypp(1:2)
        tau_new = sqrt(2 * tol / max(1E-10, maxval(ypp(:)) ))
        
        time = time + tau
        u(1) = u_n(1)
        u(2) = u_n(2)

        !tau = tau_new
        
        !write(*,*) time, u(1), u(2), i
        write(ifile,'(5es14.6)') time, u(1), u(2), maxval(est(1:2)), tau_new
        if(time > x_max) goto 10
     enddo
10   continue
     
  elseif(i_method .eq. 3) then

     write(ifile,*) 0., u(1), u(2), 0
     do i=1, k_max

        aa(1,1) = 1.D+00 - tau*a(1,1) / 2.
        aa(1,2) =  - tau*a(1,2)/ 2.
        aa(2,1) =  - tau*a(2,1)/ 2.
        aa(2,2) = 1.D+00 - tau*a(2,2)/ 2.

        det = aa(1,1)*aa(2,2) - aa(1,2)*aa(2,1)

        f(1) = u(1) + tau*(a(1,1)* u(1) + a(1,2)*u(2) )/2.
        f(2) = u(2) + tau*(a(2,1)* u(1) + a(2,2)*u(2) )/2.

        
        det1 = f(1)*aa(2,2) - f(2)*aa(1,2)
        det2 = f(2)*aa(1,1) - f(1)*aa(2,1)

        u_n(1) = det1/det
        u_n(2) = det2/det

        time = time + tau
        u(1) = u_n(1)
        u(2) = u_n(2)


        !write(*,*) time, u(1), u(2), i
        write(ifile,'(3es14.6,i5)') time, u(1), u(2), i
     enddo

  endif

  close(ifile)

  print*,'Computation finished'
end program stiff
